/***************************************************************************
 *
 *			   INFORMIX SOFTWARE, INC.
 *
 *			      PROPRIETARY DATA
 *
 *	THIS DOCUMENT CONTAINS TRADE SECRET DATA WHICH IS THE PROPERTY OF 
 *	INFORMIX SOFTWARE, INC.  THIS DOCUMENT IS SUBMITTED TO RECIPIENT IN
 *	CONFIDENCE.  INFORMATION CONTAINED HEREIN MAY NOT BE USED, COPIED OR 
 *	DISCLOSED IN WHOLE OR IN PART EXCEPT AS PERMITTED BY WRITTEN AGREEMENT 
 *	SIGNED BY AN OFFICER OF INFORMIX SOFTWARE, INC.
 *
 *	THIS MATERIAL IS ALSO COPYRIGHTED AS AN UNPUBLISHED WORK UNDER
 *	SECTIONS 104 AND 408 OF TITLE 17 OF THE UNITED STATES CODE. 
 *	UNAUTHORIZED USE, COPYING OR OTHER REPRODUCTION IS PROHIBITED BY LAW.
 *
 *
 *  Title:	int8.h
 *  Description:
 *		Header file for int8 data type.
 *
 ***************************************************************************
 */

#ifndef _INT8_H
#define _INT8_H

#include "ifxtypes.h"

#define INT8SIZE 2	   /* number of unsigned int4's in struct ifx_int8 */
#define INT8UNKNOWN -2     /* Value returned by int8 comparison function if one 
			    * of the operands is NULL.
			    */

#define INT8NULL	0  /* A int8 null will be represented internally by setting 
			    * sign equal to INT8NULL
			    */


typedef struct ifx_int8
    {
    uint4 data[INT8SIZE];
    int2 sign;		/* 0 = NULL, 1 = positive, -1 = negative */
    } ifx_int8_t;

#endif /* _INT8_H */
